package jp.gr.java_conf.matsubara.expresser;


/**
 * Zq̏ێNXłB<br/>
 * Zq͊eX int ^ID܂B<br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 *
 */
public class OperatorData {
    public static final int OP_CLS_BIN = 1;            //  񍀉Zq
    public static final int OP_CLS_FRONT_UNITY = 2;    //  OuPZq
    public static final int OP_CLS_BACK_UNITY = 3;    //  uPZq
    public static final int OP_CLS_PARENTHESIS = 4;    //  ^

    /** O`ioriginalParsergpj */
    public static final int OP_EXTERNAL_PARSED=0;    

    /** =  */
    public static final int OP_SUBSTITUTE=101;    
    /** - L */
    public static final int OP_PLUS=102;    
    /** - L */
    public static final int OP_MINUS=103;    
    /** . oANZX */
    public static final int OP_MEMBER_ACCESS=104;    
    /** ( [  */
    public static final int OP_PARENTHESIS=105;
    /** ( ֐Ăяo */
    public static final int OP_CALL_FUNCTION=106;
    /** [ zĂяo */
    public static final int OP_ARRAY_ACCESS=107;
    /** new IuWFNg */
    public static final int OP_CREATE_OBJECT=108;
    /** delete Zq */
    public static final int OP_DELETE_MEMBER=109;
    /** void Zq */
    public static final int OP_VOID=110;
    /** delete Zq */
    public static final int OP_TYPEOF=111;
    /** , Zq */
    public static final int OP_SEQUENSE=112;
    /** , Zq */
    public static final int OP_INSTANCEOF=113;

    /** + ZpZ */
    public static final int OP_ARI_ADD=201;
    /** - ZpZ */
    public static final int OP_ARI_SUB=202;    
    /** * ZpZ */
    public static final int OP_ARI_MUL=203;    
    /** / ZpZ */
    public static final int OP_ARI_DIV=204;    
    /** % Zp] */
    public static final int OP_ARI_REM=205;    

    /** || _a */
    public static final int OP_LOG_OR=301;
    /** && _ */
    public static final int OP_LOG_AND=302;
    /** !  _ے */
    public static final int OP_LOG_NOT=303;

    /** == r */
    public static final int OP_CMP_EQ=401;
    /** != r񓙉 */
    public static final int OP_CMP_NE=402;
    /** >= rȂCR[ */
    public static final int OP_CMP_GE=403;
    /** >  rȂ */
    public static final int OP_CMP_GT=404;
    /** <= rȂCR[ */
    public static final int OP_CMP_LE=405;
    /** < rȂ */
    public static final int OP_CMP_LT=406;
    /** === r */
    public static final int OP_CMP_EQ_STRICT=407;
    /** === r */
    public static final int OP_CMP_NE_STRICT=408;
    
    /** | rbga */
    public static final int OP_BIT_OR=501;
    /** & rbg */
    public static final int OP_BIT_AND=502;
    /** ~ rbg] */
    public static final int OP_BIT_NOT=503;
    /** ^ rbgrI_a */
    public static final int OP_BIT_XOR=504;
    
    /** <<  rbgVtg  */
    public static final int OP_SFT_LEFT=601;
    /** >>  rbgVtg E */
    public static final int OP_SFT_RIGHT=602;
    /** >>> rbgVtg EiȂj */
    public static final int OP_SFT_RIGHT_UNSIGNED=603;
    
    /** ++ OuCNg */
    public static final int OP_ARI_INC_F=701;
    /** -- OufNg */
    public static final int OP_ARI_DEC_F=702;
    /** ++ uCNg */
    public static final int OP_ARI_INC_B=703;
    /** -- ufNg */
    public static final int OP_ARI_DEC_B=704;
    /** += Z */
    public static final int OP_ARI_ADD_SUBS=705;
    /** -= Z */
    public static final int OP_ARI_SUB_SUBS=706;
    /** *= Z */
    public static final int OP_ARI_MUL_SUBS=707;
    /** /= Z */
    public static final int OP_ARI_DIV_SUBS=708;
    /** %= ] */
    public static final int OP_ARI_REM_SUBS=709;
    /** &= rbg */
    public static final int OP_BIT_AND_SUBS=710;
    /** |= rbga */
    public static final int OP_BIT_OR_SUBS=711;
    /** ^= rbgrI_a */
    public static final int OP_BIT_XOR_SUBS=712;
    /** <<=  rbgVtg  */
    public static final int OP_SFT_LEFT_SUBS=713;
    /** >>=  rbgVtg E */
    public static final int OP_SFT_RIGHT_SUBS=714;
    /** >>>= rbgVtg EiȂj */
    public static final int OP_SFT_RIGHT_UNSIGNED_SUBS=715;

    
    private char[] operatorChars;                //  Zq
    private int operatorValue;                        //  Zq(OperatorData.OP_*)
    private int priority;                        //  Dx
    private int opeClass;                        //  񍀉ZqEOuPZqEuPZqE
    private boolean leftVariable;                //  Iyhϐłׂtrue
    private boolean rightVariable;            //  EIyhϐłׂtrue
    private IOperatorParser originalParser;    //  Ǝ̃p[T[iLΎw\j
    
    public OperatorData(String operator, int operatorValue, int priority, int opeClass, boolean leltVariable, boolean rightVariable, IOperatorParser originalParser) {
        initialize(operator, operatorValue, priority, opeClass, leltVariable, rightVariable, originalParser);
    }

    public OperatorData(String operator, int operatorValue, int priority, int opeClass, boolean leftVariable, boolean rightVariable) {
        initialize(operator, operatorValue, priority, opeClass, leftVariable, rightVariable, null);
    }
    
    private void initialize(String operator, int operatorValue, int priority, int opeClass, boolean leftVariable, boolean rightVariable, IOperatorParser originalParser) {
        this.operatorChars = operator.toCharArray();
        this.operatorValue = operatorValue;
        this.priority = priority;
        this.opeClass = opeClass;
        this.leftVariable = leftVariable;
        this.rightVariable = rightVariable;
        this.originalParser = originalParser;
    }
    
    /**
     * Xe[gg̎wʒug̃Iy[^ƈv邩ׂ
     * @param statements Xe[gg
     * @param opeIdx ]ʒu
     * @param end Iʒu
     * @return vꍇ true
     */
    public boolean compare(char[] statements, int opeIdx, int end) {
        int max = operatorChars.length;
        //  Xe[gg̒`FbN
        if (opeIdx + max > end)
            return false;
        //  Ă邩`FbN
        for (int idx = 0; idx < max; idx++) {
            if (operatorChars[idx] != statements[opeIdx + idx])
                return false;
        }
        //  At@xbgi܂$_jn܂鉉Zq͎̕␔łĂ͂Ȃ
        char firstChar = operatorChars[0];
        if (Character.isUnicodeIdentifierStart(firstChar) || Character.isJavaIdentifierStart(firstChar)) {
            if (opeIdx + max < end) {
                char chNext = statements[opeIdx + max];
                if (Character.isUnicodeIdentifierPart(chNext) || Character.isJavaIdentifierPart(chNext)) {
                    return false;
                }
            }
        }
        
        return true;
    }
    
    
    /**
     * Zq char ^z߂
     * 
     * @return Zq char ^z 
     */
    public char[] getOperatorChars() {
        return operatorChars;
    }
    
    /**
     * Zq̎
     *  OperatorData.OP_CLS_BIN : 񍀉Zq
     *  OperatorData.OP_CLS_FRONT_UNITY : OuPZq
     *  OperatorData.OP_CLS_BACK_UNITY : uPZq
     *  OperatorData.OP_CLS_PARENTHESIS : ^
     * 
     * @return opeClass ߂܂B
     */
    public int getOpeClass() {
        return opeClass;
    }
    /**
     * Zq̔ԍԂ
     * 
     * @return Zq̔ԍ
     */
    public int getOperator() {
        return operatorValue;
    }
    /**
     * Ǝ`p[T[Ԃ
     * 
     * @return Ǝ`p[T[΂̃IuWFNgAȂ null
     */
    public IOperatorParser getOriginalParser() {
        return originalParser;
    }
    /**
     * Zq̗Dx
     * 
     * @return Zq̗Dx
     */
    public int getPriority() {
        return priority;
    }

    /**
     * IyhϐłKv邩
     * 
     * @return IyhϐłKvꍇ ture
     */
    public boolean isLeftVariable() {
        return leftVariable;
    }

    /**
     * EIyhϐłKv邩
     * 
     * @return EIyhϐłKvꍇ ture
     */
    public boolean isRightVariable() {
        return rightVariable;
    }

    public String toString() {
        return new String(operatorChars); 
    }
    
    /**
     * Zq̕\ł̒Ԃ܂B
     * @return Zq̕\ł̒ 
     */
    public int length() {
        return operatorChars.length;
    }
}
