package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * \͍ς݂̎łB<br/> 
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public interface IParsedExpression {
    /**
     * ϐpĂ邩ǂׂ܂B
     * @param id ϐID
     * @return ϐgpĂꍇ̐AgpĂȂꍇ0
     * @throws ExpException
     */
    public int isUsingVariable(Integer id) throws ExpException;
    
    /**
     * \͍ς݂̌vZۂɌvZ܂B
     * @param runtime ^Cf[^ 
     * @return vZ
     * @throws ExpException
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException;
    
    /**
     * \łΌvZ̎QƂ𓾂܂B<br/>
     * QƂƂ͑\Ȏ̂ƂłB̓Iɂ͕ϐłAoANZXZqAzANZXZqłB
     * QƂ𓾂邱ƂłȂꍇ͗O𐶐܂B
     * @param runtime ^Cf[^ 
     * @return Q
     * @throws ExpException
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException;

    /**
     * ΏۂƂȂIuWFNgԂ܂B<br/>
     *  xxx.yyy() ̃\bhĂяoɂ xxx \܂B
     * @param runtime ^Cf[^
     * @return ΏۂƂȂIuWFNg
     * @throws ExpException
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException;
    
    
    /**
     * \͂ꂽvZ萔ł邩f܂B
     * @return \͂ꂽvZ萔łꍇ true
     */
    public boolean isConst();

}
