package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type.JavaObject;

/**
 * String^ toCharArray() \bhłB<br/>
 * ̃\bh ECMA262 ̃\bhł͂܂B<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class String__toCharArray extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("toCharArray");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__toCharArray() throws ExpException {
        super("toCharArray", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();
        return new JavaObject(value.toCharArray());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new String__toCharArray();
        return instance;
    }
}
