package jp.gr.java_conf.matsubara.interpreter;

import jp.gr.java_conf.matsubara.expresser.ExpTypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

/**
 * XNvgs邽߂̃XbhłB
 * 
 * 쐬: 2005/05/25
 * 
 * @author m.matsubara
 */

public class ScriptThread extends Thread {
    private ParsedScript script;
    private RuntimeData runtime;
    
    /**
     * XNvgs邽߂̃Xbh쐬܂B
     * @param script ͍ς݃XNvg
     */
    public ScriptThread(ParsedScript script) {
        this.script = script;
        runtime = new RuntimeData(script.getDefaultRuntime());
        runtime.setTypeConverter(new ExpTypeConverter());
    }

    /* ( Javadoc)
     * @see java.lang.Runnable#run()
     */
    public void run() {
        try {
            script.execute(runtime);
        } catch (ExpException ee) {
            ee.printStackTrace();
        }
    }
}
