package jp.gr.java_conf.matsubara.expresser.type;

import java.util.ArrayList;
import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

public class JavaObject implements IExpObject {
    private Object object;
    
    public JavaObject(Object object) {
        this.object = object;
    }

    public IExpObject getProperty(Integer id) throws ExpException {
        JavaObjectMember member = new JavaObjectMember(object, StringToId.toString(id));
        try {
            //  TODO JavaObject̃\bhvpeBƂČĂяoꍇ̓l
            //  TODO JavaObjectMember IVariablepĂėǂlB
            IExpObject memberVal = member.getValue();
            return memberVal;
        } catch (ExpException ee) {
            return member;
        }
    }

    public void putProperty(Integer id, IExpObject value) throws ExpException {
        JavaObjectMember member = new JavaObjectMember(object, StringToId.toString(id));
        member.setValue(value);
    }

    public IExpObject getProperty(int index) throws ExpException {
        return Expresser.UNDEFINED;
    }

    public void putProperty(int index, IExpObject value) throws ExpException {
        
    }

    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        return true;    //  TODO ܂
    }

    public Integer[] enumProperty() {
        return new Integer[] {};    //  TODO ܂
    }
    
    public IExpObject deleteProperty(Integer id) throws ExpException {
        return new _Boolean(true);
    }

    public List getConstructorList() {
        return new ArrayList(0);
    }

    public IVariable getVariable(Integer id) {
        JavaObjectMember member = new JavaObjectMember(object, StringToId.toString(id));
        return member;
    }

    public IVariable getVariable(int Index) {
        return null;    // TODO ͂܂낤B
    }

    public Object getObject() {
        return object;
    }
    
    public String toString() {
        return object.toString();
    }
}
