package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Global^ escape() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/30
 * 
 * @author m.matsubara
 */

public class Global__escape extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("escape");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__escape() throws ExpException {
        super("escape", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        String uri = runtime.getTypeConverter().toString(runtime, arguments[0]).toString();
        StringBuffer result = new StringBuffer(uri.length() * 12 / 10);
        int max = uri.length();
        for (int idx = 0; idx < max; idx++) {
            char ch = uri.charAt(idx);
            if (ch > 256) {
            //  }`oCg
            result.append("%u");
            result.append(Global__encodeURI.toHexString(ch).toUpperCase());
            } else if (Character.isLetterOrDigit(ch) || ch == '+' || ch == '-' || ch == '*' || ch == '/' || ch == '.' || ch == '_' || ch == '@') {
                //  ASCII  At@xbgEEꕔ̋L
                result.append(ch);
            } else {
                //  ̑̋LiASCIIj
                result.append('%');
                result.append(Global__encodeURI.toHexString(ch).toUpperCase());
            }
        }
        return new _String(result.toString());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__escape();
        return instance;
    }
}
