package jp.gr.java_conf.matsubara.interpreter.ecmascript.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.interpreter.ParsedScript;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;

/**
 * GlobalIuWFNg eval() \bhłB<br/>
 * ̃\bhScriptEngineɈˑ邽߁Aexpresser̉ł͂ȂAɂB
 * <br/>
 * 쐬: 2005/07/28
 * 
 * @author m.matsubara
 */
public class Global__eval extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("eval");
    private static IExpObject instance = null;  

    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__eval() throws ExpException {
        super("eval", 1);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        ITypeConverter typeConverter = runtime.getTypeConverter();
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        String script = typeConverter.toString(runtime, arguments[0]).toString();
        ScriptEngine scriptEngine = new ScriptEngine();
        scriptEngine.getExpresser().setDefaultRuntimeData(runtime);
        ParsedScript parcedScript = scriptEngine.parse(script);
        parcedScript.execute(runtime);
        
        return runtime.getLastResultValue();
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__eval();
        return instance;
    }

    public void putProperty(Integer id, IExpObject value) throws ExpException {
        // TODO Auto-generated method stub
        
    }

    public void putProperty(int index, IExpObject value) throws ExpException {
        // TODO Auto-generated method stub
        
    }
}
